// HTMLHelpView.cpp : Implementierung der Klasse CHTMLHelpView
//

#include "stdafx.h"
#include "HTMLHelp.h"

#include "HTMLHelpDoc.h"
#include "HTMLHelpView.h"
#include "HTMLHelpDefines.h"
#include "DialogHirnlos.h"

//Ntig fr WM_COMMANDHELP und WM_HELPHITTEST!
#include <afxpriv.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CHTMLHelpView

IMPLEMENT_DYNCREATE(CHTMLHelpView, CView)

BEGIN_MESSAGE_MAP(CHTMLHelpView, CView)
	// Standarddruckbefehle
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_WM_LBUTTONDOWN()
	ON_MESSAGE (WM_COMMANDHELP, OnCommandHelp)  
	ON_MESSAGE (WM_HELPHITTEST, OnHelpHitTest)
	ON_COMMAND(ID_EDIT_MENUEPUNKT, &CHTMLHelpView::OnEditMenuepunkt)
	ON_WM_HELPINFO()
END_MESSAGE_MAP()

// CHTMLHelpView-Erstellung/Zerstrung

CHTMLHelpView::CHTMLHelpView()
: pointClick(0)
{
	// TODO: Hier Code zur Konstruktion einfgen

	//Den Klick-Punkt mit "-1/-1" initialisieren (nichts gewhlt).
	this->pointClick.x = -1;
	this->pointClick.y = -1;
}

CHTMLHelpView::~CHTMLHelpView()
{
}

BOOL CHTMLHelpView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ndern Sie hier die Fensterklasse oder die Darstellung, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CView::PreCreateWindow(cs);
}

// CHTMLHelpView-Zeichnung

void CHTMLHelpView::OnDraw(CDC* pDC)
{
	CHTMLHelpDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: Code zum Zeichnen der systemeigenen Daten hinzufgen

	//Pen fr die Rahmenfarbe (Gelb, Breite 2) in den Devicecontext schieben.
	CPen penBorder (PS_SOLID, 2, RGB (255, 255, 0) );
	CPen* penOlde = pDC->SelectObject (&penBorder);

	//Linkes Rechteck zeichnen:
	CBrush brushLinks (RGB (255, 0, 0) );
	CRect rectLinks (0, 0, 200, 200);
	//Ist dies das aktuell geklickte Rechteck ?
	if (rectLinks.PtInRect (this->pointClick) == TRUE)
	{
		//Rechteck mit Fllfarbe und Rahmen in Farbe x zeichnen:
		CBrush* brushOlde = pDC->SelectObject (&brushLinks);
		pDC->Rectangle (rectLinks);
		pDC->SelectObject (brushOlde);
	}
	else
	{
		pDC->FillRect (rectLinks, &brushLinks);
	}

	//Zweites Rechteck:
	CBrush brushRechts (RGB (0, 0, 255) );
	CRect rectRechts (200, 0, 400, 200);
	pDC->FillRect (rectRechts, &brushRechts);
	//Ist dies das aktuell geklickte Rechteck ?
	if (rectRechts.PtInRect (this->pointClick) == TRUE)
	{
		//Rechteck mit Fllfarbe und Rahmen in Farbe x zeichnen:
		CBrush* brushOlde = pDC->SelectObject (&brushRechts);
		pDC->Rectangle (rectRechts);
		pDC->SelectObject (brushOlde);
	}
	else
	{
		pDC->FillRect (rectRechts, &brushRechts);
	}

	//Pen zurckselektiewren:
	pDC->SelectObject (penOlde);
}


// CHTMLHelpView drucken

BOOL CHTMLHelpView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Standardvorbereitung
	return DoPreparePrinting(pInfo);
}

void CHTMLHelpView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Zustzliche Initialisierung vor dem Drucken hier einfgen
}

void CHTMLHelpView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: Bereinigung nach dem Drucken einfgen
}


// CHTMLHelpView-Diagnose

#ifdef _DEBUG
void CHTMLHelpView::AssertValid() const
{
	CView::AssertValid();
}

void CHTMLHelpView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CHTMLHelpDoc* CHTMLHelpView::GetDocument() const // Nicht-Debugversion ist inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CHTMLHelpDoc)));
	return (CHTMLHelpDoc*)m_pDocument;
}
#endif //_DEBUG


// CHTMLHelpView-Meldungshandler

void CHTMLHelpView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Fgen Sie hier Ihren Meldungsbehandlungscode ein, und/oder benutzen Sie den Standard.
	//Punkt des Klicks in Instanzvariable speichern:
	this->pointClick = point;

	//Neu zeichnen:
	this->Invalidate ();

	CView::OnLButtonDown(nFlags, point);
}

/**Ermitteln der aktuell gltigen Hilfe (je nach Context !)
 * @param pointClicked Ein Punkt auf der view fr den die Hilfe gesucht wird.
 * @return Hilfe-ID fr "Rechteck links", "Rechteck rechts" oder "Kein Rechtecke",
 * je nachdem wohin geklickt wurde.
 */
int CHTMLHelpView::GetHelpID (CPoint pointClicked)
{
	//Die beiden Rechtecke:
	CRect rectLinks (0, 0, 200, 200);
	CRect rectRechts (200, 0, 400, 200);

	//In welchem Rechteck steckt der Punkt ?
	if (rectLinks.PtInRect (pointClicked) == TRUE)
		return HTMLHELP_RECHTECK_LINKS;
	else if (rectRechts.PtInRect (pointClicked) == TRUE)
		return HTMLHELP_RECHTECK_RECHTS;
	else
		return HTMLHELP_RECHTECK_NONE;
}

/**CWnd::OnHelp sendet WM_COMMANDHELP an das Fenster mit dem Fokus und  ann
 * alle dessen Besitzer. Dies ist unsere Chance die kontextsensitive Hilfe
 * anzuzeigen.
 * @param lParam 
 * Aus "axfpriv.h":
 * #define WM_COMMANDHELP      0x0365   // lResult = TRUE/FALSE,
 *                                      // lParam = dwContext
 * Beim Aufruf aus OnHelp ist der lParam allerdings immer 0.
 */
LRESULT CHTMLHelpView::OnCommandHelp(WPARAM, LPARAM lParam)
{
	DWORD dwContextID = this->GetHelpID (this->pointClick);
	AfxGetApp ()->HtmlHelp (dwContextID, HH_HELP_CONTEXT);
	return TRUE;
}


/**Message WM_HELPHITTEST verarbeiten: Help-ID zum Punkt holen.
 * @param wParam uninteressant
 * @param lParam Enthlt im LoWord die x-Koordinate, im HighWord die y-Koordinate
 * des geklickten Punkts.
 * @return Eine der drei Help-Ids des Fensters.
 */
LRESULT CHTMLHelpView::OnHelpHitTest(WPARAM wParam, LPARAM lParam)
{
	return this->GetHelpID( CPoint ( LOWORD(lParam), HIWORD (lParam) ) );
}

/**Message WM_HELPINFO verarbeiten. Dient dazu nicht nur das Hilfethema auszuwhlen
 * sondern auch die Seite anzuzeigen. 
 * @param pHelpInfo Eine HelpInfo-Struktur in deren Member "dwContextID" die ID 
 * der anzuzeigenden Seite geschrieben wird.
 * @return Immer TRUE da das Event verarbeitet wurde.
 */
BOOL CHTMLHelpView::OnHelpInfo(HELPINFO* pHelpInfo)
{
	//Geklicktes Rechteck ermitteln:
	pHelpInfo->dwContextId = this->GetHelpID ( CPoint (pHelpInfo->MousePos.x, pHelpInfo->MousePos.y) );

	return TRUE;
}

/**Der einzige Menpunkt wird gewhlt. Einen Dialog anzeigen.
 *
 */
void CHTMLHelpView::OnEditMenuepunkt()
{
	CDialogHirnlos dialog;
	dialog.DoModal();
}
